This endpoint is used to query a configuration entity with a provided configurationId.
Note: the type of configuration in operation response is a union of different configuration types. Configuration type is denoted by transformType property. API consumers should expect that new configuration types will added in the future. New configurations may have a different schema than the ones that currently exist so configuration should be deserialized based on transformType.
Authentication
Requires Authorization header with valid Bearer token for scope itwin-platform.
For more documentation on authorization and how to get access token visit OAUTH2 Authorization page.
Authorization
You must have imodels_read assigned for the target iModel and imodels_read assigned for the source iModel within related configuration.
You can check iModel permissions here.
Rate limits
All iTwin Platform API operations have a rate limit. For more documentation on that visit Rate limits and quotas page.
Request parameters
ID of the configuration
Request headers
OAuth access token with itwin-platform scope
Setting to application/vnd.bentley.itwin-platform.v2+json is recommended.
Response 200 OK
Returns a configuration for the given Id.
{ "configuration": { "id": "00000000-0000-0000-0000-000000000000", "name": "Transformation name", "changesetDescription": "Example description", "createdDateTime": "2021-08-02T02:51:33Z", "modifiedDateTime": "2021-08-02T02:51:33Z", "transformType": "FilterBySavedView", "transformParameters": { "_links": { "savedView": { "href": "https://api.bentley.com/savedViews/AAAaa0AAaa0AaAAAAaaAAAaAaA-AAA000AAaaa0_Aa0AOa0aaAA0A-a0a0AA-Aa0AAa" } }, "viewMode": "IncludeNewContent" }, "_links": { "sourceIModel": { "href": "https://api.bentley.com/imodels/00000000-0000-0000-0000-000000000000" }, "targetIModel": { "href": "https://api.bentley.com/imodels/00000000-0000-0000-0000-000000000000" } } } }
Response 401 Unauthorized
This response indicates that request lacks valid authentication credentials. Access token might not been provided, issued by the wrong issuer, does not have required scopes or request headers were malformed.
{ "error": { "code": "HeaderNotFound", "message": "Header Authorization was not found in the request. Access denied." } }
Response 404 Not Found
Configuration with the given Id does not exist.
{ "error": { "code": "ConfigurationNotFound", "message": "Requested Configuration is not available.", "target": "00000000-0000-0000-0000-000000000000" } }
Response 429 Too many requests
This response indicates that the client sent more requests than allowed by this API for the current tier of the client.
{ "error": { "code": "RateLimitExceeded", "message": "The client sent more requests than allowed by this API for the current tier of the client." } }
Response headers
Number of seconds to wait until client is allowed to make more requests.
Link
Link to a resource.
{ "title": "Link", "type": "object", "properties": { "href": { "type": "string", "description": "Link to a resource." } }, "additionalProperties": false }
Link to a configuration
{ "title": "Link to a configuration", "type": "object", "properties": { "configuration": { "$ref": "#/components/schemas/Link" } }, "additionalProperties": false }
Error
Contains error information.
One of a server-defined set of error codes.
A human-readable representation of the error.
The target of the error.
{ "required": [ "code", "message" ], "type": "object", "properties": { "code": { "type": "string", "description": "One of a server-defined set of error codes." }, "message": { "type": "string", "description": "A human-readable representation of the error." }, "target": { "type": "string", "description": "The target of the error.", "nullable": true } }, "description": "Contains error information." }
Error Response
Gives details for an error that occurred while handling the request. Note that clients MUST NOT assume that every failed request will produce an object of this schema, or that all of the properties in the response will be non-null, as the error may have prevented this response from being constructed.
{ "title": "Error Response", "required": [ "error" ], "type": "object", "properties": { "error": { "$ref": "#/components/schemas/Error" } }, "additionalProperties": false, "description": "Gives details for an error that occurred while handling the request. Note that clients MUST NOT assume that every failed request will produce an object of this schema, or that all of the properties in the response will be non-null, as the error may have prevented this response from being constructed." }
EC schema definition
EC Schema name
EC Schema version
{ "title": "EC schema definition", "required": [ "ecSchemaName", "ecSchemaVersion" ], "type": "object", "properties": { "ecSchemaName": { "type": "string", "description": "EC Schema name", "example": "BisCore" }, "ecSchemaVersion": { "type": "string", "description": "EC Schema version", "example": "01.00.14" } }, "additionalProperties": false }
EC class definition
EC Schema name
EC Class name
{ "title": "EC class definition", "required": [ "ecSchemaName", "ecClassName" ], "type": "object", "properties": { "ecSchemaName": { "type": "string", "description": "EC Schema name", "example": "BisCore" }, "ecClassName": { "type": "string", "description": "EC Class name", "example": "GraphicalElement3d" } }, "additionalProperties": false }
Element group properties
{ "title": "Element group properties", "required": [ "elementPropertyQuery", "targetECClass" ], "type": "object", "properties": { "elementPropertyQuery": { "type": "string", "description": "ECSql query", "example": "SELECT ECInstanceId FROM Generic.PhysicalObject" }, "targetECClass": { "$ref": "#/components/schemas/TParams_Common_ECClassDefinition" } }, "additionalProperties": false }
Data remapping options
Array of EC schemas that will be added to target iModel after transformation.
{ "title": "Data remapping options", "required": [ "elementGroups" ], "type": "object", "properties": { "additionalECSchemas": { "type": "array", "items": { "$ref": "#/components/schemas/TParams_Common_ECSchemaDefinition" }, "description": "Array of EC schemas that will be added to target iModel after transformation." }, "elementGroups": { "type": "array", "items": { "$ref": "#/components/schemas/TParams_AlignIModelData_ElementGroup" }, "description": "Array of element groups that are to be remapped." } }, "additionalProperties": false }
EC Class merging group
Array of EC classes that will be merged into the target class.
{ "title": "EC Class merging group", "required": [ "targetECClass", "sourceECClasses" ], "type": "object", "properties": { "targetECClass": { "$ref": "#/components/schemas/TParams_Common_ECClassDefinition" }, "sourceECClasses": { "type": "array", "items": { "$ref": "#/components/schemas/TParams_Common_ECClassDefinition" }, "description": "Array of EC classes that will be merged into the target class." } }, "additionalProperties": false }
Schema optimization options
Option to remove unused EC classes from dynamic EC schemas.
{ "title": "Schema optimization options", "type": "object", "properties": { "removeUnusedClasses": { "type": "boolean", "description": "Option to remove unused EC classes from dynamic EC schemas." }, "classMergingGroups": { "type": "array", "items": { "$ref": "#/components/schemas/TParams_AlignIModelData_ClassMergingGroup" }, "description": "Array of EC class merging groups" } }, "additionalProperties": false }
Align iModel data configuration properties
{ "title": "Align iModel data configuration properties", "type": "object", "properties": { "dataRemappingOptions": { "$ref": "#/components/schemas/TParams_AlignIModelData_DataRemappingOptions" }, "schemaOptimizationOptions": { "$ref": "#/components/schemas/TParams_AlignIModelData_SchemaOptimizationOptions" } }, "additionalProperties": false }
Links
{ "title": "Links", "type": "object", "properties": { "sourceIModel": { "$ref": "#/components/schemas/Link" }, "targetIModel": { "$ref": "#/components/schemas/Link" } }, "additionalProperties": false }
Align iModel data configuration properties transformType
Type of the transformation.
{ "enum": [ "AlignIModelData" ], "type": "string", "description": "Type of the transformation.", "title": "Align iModel data configuration properties transformType" }
Align iModel data configuration properties
Configuration data.
ID of the configuration.
User friendly name of the transformation.
Description for the changeset created after transformation.
Time the configuration was created at.
Time the configuration was last modified at.
Type of the transformation.
{ "title": "Align iModel data configuration properties", "required": [ "id", "name", "changesetDescription", "createdDateTime", "modifiedDateTime", "transformType", "_links" ], "type": "object", "properties": { "id": { "type": "string", "description": "ID of the configuration.", "example": "00000000-0000-0000-0000-000000000000" }, "name": { "type": "string", "description": "User friendly name of the transformation.", "example": "Example name" }, "changesetDescription": { "type": "string", "description": "Description for the changeset created after transformation.", "example": "Example comment" }, "createdDateTime": { "type": "string", "description": "Time the configuration was created at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "modifiedDateTime": { "type": "string", "description": "Time the configuration was last modified at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "transformType": { "enum": [ "AlignIModelData" ], "type": "string", "description": "Type of the transformation.", "title": "Align iModel data configuration properties transformType", "$ref": "#/components/schemas/Configuration_AlignIModelData-transformType" }, "transformParameters": { "$ref": "#/components/schemas/TParams_AlignIModelData" }, "_links": { "$ref": "#/components/schemas/Links_ConfigurationData" } }, "additionalProperties": false, "description": "Configuration data." }
View mode
Specifies saved view mode. 'FilterContent' filters out all new content that was introduced into the iModel after the view was created. 'IncludeNewContent' includes all new content that was introduced into the iModel after the view was created.
{ "title": "View mode", "enum": [ "IncludeNewContent", "FilterContent" ], "type": "string", "description": "Specifies saved view mode. **'FilterContent'** filters out all new content that was introduced into the iModel after the view was created. **'IncludeNewContent'** includes all new content that was introduced into the iModel after the view was created. " }
Saved view link
{ "title": "Saved view link", "type": "object", "properties": { "savedView": { "$ref": "#/components/schemas/Link" } }, "additionalProperties": false }
Filter by saved view configuration properties
{ "title": "Filter by saved view configuration properties", "type": "object", "properties": { "_links": { "$ref": "#/components/schemas/Links_SavedView" }, "viewMode": { "$ref": "#/components/schemas/ViewMode" } }, "additionalProperties": false }
Filter by saved view configuration properties transformType
Type of the transformation.
{ "enum": [ "FilterBySavedView" ], "type": "string", "description": "Type of the transformation.", "title": "Filter by saved view configuration properties transformType" }
Filter by saved view configuration properties
Configuration data.
ID of the configuration.
User friendly name of the transformation.
Description for the changeset created after transformation.
Time the configuration was created at.
Time the configuration was last modified at.
Type of the transformation.
{ "title": "Filter by saved view configuration properties", "required": [ "id", "name", "changesetDescription", "createdDateTime", "modifiedDateTime", "transformType", "_links" ], "type": "object", "properties": { "id": { "type": "string", "description": "ID of the configuration.", "example": "00000000-0000-0000-0000-000000000000" }, "name": { "type": "string", "description": "User friendly name of the transformation.", "example": "Example name" }, "changesetDescription": { "type": "string", "description": "Description for the changeset created after transformation.", "example": "Example comment" }, "createdDateTime": { "type": "string", "description": "Time the configuration was created at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "modifiedDateTime": { "type": "string", "description": "Time the configuration was last modified at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "transformType": { "enum": [ "FilterBySavedView" ], "type": "string", "description": "Type of the transformation.", "title": "Filter by saved view configuration properties transformType", "$ref": "#/components/schemas/Configuration_FilterBySavedView-transformType" }, "transformParameters": { "$ref": "#/components/schemas/TParams_FilterBySavedView" }, "_links": { "$ref": "#/components/schemas/Links_ConfigurationData" } }, "additionalProperties": false, "description": "Configuration data." }
Filter iModel configuration properties
{ "title": "Filter iModel configuration properties", "required": [ "ecSql" ], "type": "object", "properties": { "ecSql": { "type": "string" }, "inclusive": { "type": "boolean" }, "includeChildren": { "type": "boolean" } }, "additionalProperties": false }
Filter iModel configuration transformType
Type of the transformation.
{ "enum": [ "FilterIModel" ], "type": "string", "description": "Type of the transformation.", "title": "Filter iModel configuration transformType" }
Filter iModel configuration
Configuration data.
ID of the configuration.
User friendly name of the transformation.
Description for the changeset created after transformation.
Time the configuration was created at.
Time the configuration was last modified at.
Type of the transformation.
{ "title": "Filter iModel configuration", "required": [ "id", "name", "changesetDescription", "createdDateTime", "modifiedDateTime", "transformType", "_links" ], "type": "object", "properties": { "id": { "type": "string", "description": "ID of the configuration.", "example": "00000000-0000-0000-0000-000000000000" }, "name": { "type": "string", "description": "User friendly name of the transformation.", "example": "Example name" }, "changesetDescription": { "type": "string", "description": "Description for the changeset created after transformation.", "example": "Example comment" }, "createdDateTime": { "type": "string", "description": "Time the configuration was created at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "modifiedDateTime": { "type": "string", "description": "Time the configuration was last modified at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "transformType": { "enum": [ "FilterIModel" ], "type": "string", "description": "Type of the transformation.", "title": "Filter iModel configuration transformType", "$ref": "#/components/schemas/Configuration_FilterIModel-transformType" }, "transformParameters": { "$ref": "#/components/schemas/TParams_FilterIModel" }, "_links": { "$ref": "#/components/schemas/Links_ConfigurationData" } }, "additionalProperties": false, "description": "Configuration data." }
ImportIModel configuration properties
{ "title": "ImportIModel configuration properties", "type": "object", "properties": { "fedGuidsOfRepositoriesToExport": { "maxItems": 1, "type": "array", "items": { "type": "string" } } }, "additionalProperties": false }
Import iModel configuration properties transformType
Type of the transformation.
{ "enum": [ "ImportIModel" ], "type": "string", "description": "Type of the transformation.", "title": "Import iModel configuration properties transformType" }
Import iModel configuration properties
ID of the configuration.
User friendly name of the transformation.
Description for the changeset created after transformation.
Time the configuration was created at.
Time the configuration was last modified at.
Type of the transformation.
{ "title": "Import iModel configuration properties", "required": [ "id", "name", "changesetDescription", "createdDateTime", "modifiedDateTime", "transformType", "_links" ], "type": "object", "properties": { "id": { "type": "string", "description": "ID of the configuration.", "example": "00000000-0000-0000-0000-000000000000" }, "name": { "type": "string", "description": "User friendly name of the transformation.", "example": "Example name" }, "changesetDescription": { "type": "string", "description": "Description for the changeset created after transformation.", "example": "Example comment" }, "createdDateTime": { "type": "string", "description": "Time the configuration was created at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "modifiedDateTime": { "type": "string", "description": "Time the configuration was last modified at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "transformType": { "enum": [ "ImportIModel" ], "type": "string", "description": "Type of the transformation.", "title": "Import iModel configuration properties transformType", "$ref": "#/components/schemas/Configuration_ImportIModel-transformType" }, "transformParameters": { "$ref": "#/components/schemas/TParams_ImportIModel" }, "_links": { "$ref": "#/components/schemas/Links_ConfigurationData" } }, "additionalProperties": false }
Merge iModel configuration properties transformType
Type of the transformation.
{ "enum": [ "MergeIModel" ], "type": "string", "description": "Type of the transformation.", "title": "Merge iModel configuration properties transformType" }
Merge iModel configuration properties
ID of the configuration.
User friendly name of the transformation.
Description for the changeset created after transformation.
Time the configuration was created at.
Time the configuration was last modified at.
Type of the transformation.
{ "title": "Merge iModel configuration properties", "required": [ "id", "name", "changesetDescription", "createdDateTime", "modifiedDateTime", "transformType", "_links" ], "type": "object", "properties": { "id": { "type": "string", "description": "ID of the configuration.", "example": "00000000-0000-0000-0000-000000000000" }, "name": { "type": "string", "description": "User friendly name of the transformation.", "example": "Example name" }, "changesetDescription": { "type": "string", "description": "Description for the changeset created after transformation.", "example": "Example comment" }, "createdDateTime": { "type": "string", "description": "Time the configuration was created at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "modifiedDateTime": { "type": "string", "description": "Time the configuration was last modified at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "transformType": { "enum": [ "MergeIModel" ], "type": "string", "description": "Type of the transformation.", "title": "Merge iModel configuration properties transformType", "$ref": "#/components/schemas/Configuration_MergeIModel-transformType" }, "_links": { "$ref": "#/components/schemas/Links_ConfigurationData" } }, "additionalProperties": false }
Single iModel Configuration Links
{ "title": "Single iModel Configuration Links", "type": "object", "properties": { "iModel": { "$ref": "#/components/schemas/Link" } }, "additionalProperties": false }
Populate Federation Guids configuration properties transformType
Type of the transformation.
{ "enum": [ "PopulateFederationGuids" ], "type": "string", "description": "Type of the transformation.", "title": "Populate Federation Guids configuration properties transformType" }
Populate Federation Guids configuration properties
ID of the configuration.
User friendly name of the transformation.
Description for the changeset created after transformation.
Time the configuration was created at.
Time the configuration was last modified at.
Type of the transformation.
{ "title": "Populate Federation Guids configuration properties", "required": [ "id", "name", "changesetDescription", "createdDateTime", "modifiedDateTime", "transformType", "_links" ], "type": "object", "properties": { "id": { "type": "string", "description": "ID of the configuration.", "example": "00000000-0000-0000-0000-000000000000" }, "name": { "type": "string", "description": "User friendly name of the transformation.", "example": "Example name" }, "changesetDescription": { "type": "string", "description": "Description for the changeset created after transformation.", "example": "Example comment" }, "createdDateTime": { "type": "string", "description": "Time the configuration was created at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "modifiedDateTime": { "type": "string", "description": "Time the configuration was last modified at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "transformType": { "enum": [ "PopulateFederationGuids" ], "type": "string", "description": "Type of the transformation.", "title": "Populate Federation Guids configuration properties transformType", "$ref": "#/components/schemas/Configuration_PopulateFederationGuids-transformType" }, "_links": { "$ref": "#/components/schemas/Links_SingleIModelConfigurationData" } }, "additionalProperties": false }
Remove imported data configuration properties
{ "title": "Remove imported data configuration properties", "type": "object", "properties": { "_links": { "$ref": "#/components/schemas/Links_Configuration" } }, "additionalProperties": false }
Remove imported data configuration properties transformType
Type of the transformation.
{ "enum": [ "RemoveImportedData" ], "type": "string", "description": "Type of the transformation.", "title": "Remove imported data configuration properties transformType" }
Remove imported data configuration properties
Configuration data.
ID of the configuration.
User friendly name of the transformation.
Description for the changeset created after transformation.
Time the configuration was created at.
Time the configuration was last modified at.
Type of the transformation.
{ "title": "Remove imported data configuration properties", "required": [ "id", "name", "changesetDescription", "createdDateTime", "modifiedDateTime", "transformType", "transformParameters", "_links" ], "type": "object", "properties": { "id": { "type": "string", "description": "ID of the configuration.", "example": "00000000-0000-0000-0000-000000000000" }, "name": { "type": "string", "description": "User friendly name of the transformation.", "example": "Example name" }, "changesetDescription": { "type": "string", "description": "Description for the changeset created after transformation.", "example": "Example comment" }, "createdDateTime": { "type": "string", "description": "Time the configuration was created at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "modifiedDateTime": { "type": "string", "description": "Time the configuration was last modified at.", "format": "date-time", "example": "0000-00-00T00:00:00.0000000Z" }, "transformType": { "enum": [ "RemoveImportedData" ], "type": "string", "description": "Type of the transformation.", "title": "Remove imported data configuration properties transformType", "$ref": "#/components/schemas/Configuration_RemoveImportedData-transformType" }, "transformParameters": { "$ref": "#/components/schemas/TParams_RemoveImportedData" }, "_links": { "$ref": "#/components/schemas/Links_ConfigurationData" } }, "additionalProperties": false, "description": "Configuration data." }
Configuration
{ "title": "Configuration", "type": "object", "properties": { "configuration": { "oneOf": [ { "$ref": "#/components/schemas/Configuration_FilterBySavedView" }, { "$ref": "#/components/schemas/Configuration_FilterIModel" }, { "$ref": "#/components/schemas/Configuration_ImportIModel" }, { "$ref": "#/components/schemas/Configuration_PopulateFederationGuids" }, { "$ref": "#/components/schemas/Configuration_MergeIModel" }, { "$ref": "#/components/schemas/Configuration_AlignIModelData" }, { "$ref": "#/components/schemas/Configuration_RemoveImportedData" } ], "description": "Single configuration", "nullable": true } }, "additionalProperties": false }
Was this page helpful?